// a class to handle ARGB image data, like window icons :)

#ifndef ARGBDATA_HEADER_INCLUDED
#define ARGBDATA_HEADER_INCLUDED

#include "xlib.h"
#include "config.h"
#include <vector>
#include <string>

namespace Visibility {

class ARGBData {
	public:
		ARGBData(CARD32 * data, unsigned width, unsigned height);
		/* xlib makes babies cry */
		ARGBData(long * data, unsigned width, unsigned height);
#if USE_PNG
		// uses libpng to read image data from file
		ARGBData(const std::string & file_path);
#endif

		// grabs image data from 'pixmap' and uses 'mask' as some sort of alpha
		// channel giving thingy.
		ARGBData(Pixmap pixmap, Pixmap mask = 0);
		~ARGBData();

		inline unsigned get_width(void) {return width;}
		inline unsigned get_height(void) {return height;}

		// returns an XImage* of the specified dimensions
		// (scaled)
		XImage * to_ximage(unsigned width, unsigned height, CARD32 bg_colour);

		void apply_tint(CARD32 tint, double amount); // amount from 0 to 1

	protected:
		// vector is much nicer than a hoboarray
		std::vector<CARD32> data;
		unsigned width;
		unsigned height;
};

}

#endif
